/**
 * Reload the source when an error is detected as long as there
 * wasn't an error previously within the last 30 seconds
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var reloadSourceOnError = function reloadSourceOnError() {
  var player = this;
  var lastCalled = 0;
  var reloadSource = function reloadSource() {
    var tech = player.tech({ IWillNotUseThisInPlugins: true });
    var sourceObj = tech.currentSource_;
    var seekTo = player.duration() !== Infinity && player.currentTime() || 0;

    if (Date.now() - lastCalled < 30 * 1000) {
      return;
    }
    lastCalled = Date.now();

    if (seekTo) {
      player.one('loadedmetadata', function () {
        player.currentTime(seekTo);
      });
    }

    player.src(sourceObj);
    player.play();
  };

  player.on('error', reloadSource);
  player.on('dispose', function () {
    player.off('error', reloadSource);
  });
};

exports['default'] = reloadSourceOnError;
module.exports = exports['default'];